#include "adminwindow.h"
#include "ui_adminwindow.h"

adminwindow::adminwindow(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::adminwindow)
{

    this->newTestWidget = new addNewTestWidget(this);
    newTestWidget->hide();
    this->deleteWidget = new deletetestwidget(this);
    deleteWidget->hide();

    ui->pushButton = new QPushButton("Назад");


    this->resize(1080,1980);
    ui->setupUi(this);
    ui->pushButton->hide();
    QPalette qpalette;
    qpalette.setColor(this->backgroundRole(), QColor("#FFCCFF"));
    this->setAutoFillBackground(true);
    this->setPalette(qpalette);

    this->setWindowTitle("Окно администратора");

    db = QSqlDatabase::addDatabase("QPSQL");
    db.setHostName("localhost");
    db.setDatabaseName("android_tester");
    db.setPort(5432);
    db.setUserName("postgres");
    db.setPassword("3868652");
    db.open();

    deleteWidget->setDb(db);

    results = new QTableView(this);
    results->hide();

    connect(ui->addNewTestBtn, SIGNAL(clicked()), this, SLOT(addNewTest()));
    connect(ui->addNewTestBtn, SIGNAL(clicked()), this, SLOT(hideStartWindow()));

    connect(newTestWidget->returnButton, SIGNAL(clicked()), this->newTestWidget, SLOT(hide()));
    connect(newTestWidget->returnButton, SIGNAL(clicked()), this, SLOT(showStartWindow()));

    connect(deleteWidget->returnButton, SIGNAL(clicked()), this->deleteWidget, SLOT(hide()));
    connect(deleteWidget->returnButton, SIGNAL(clicked()), this, SLOT(showStartWindow()));

    connect(ui->checkProgressBtn, SIGNAL(clicked()), this, SLOT(checkStats()));
    connect(ui->checkProgressBtn, SIGNAL(clicked()), this, SLOT(hideStartWindow()));

    connect(ui->pushButton, SIGNAL(clicked()), this, SLOT(showStartWindow()));
    connect(ui->pushButton, SIGNAL(clicked()), this->results, SLOT(hide()));

    connect(ui->deleteTestBtn, SIGNAL(clicked()), this, SLOT(deleteTest()));
    connect(ui->deleteTestBtn, SIGNAL(clicked()), this, SLOT(hideStartWindow()));

}

adminwindow::~adminwindow()
{
    delete ui;
}

void adminwindow::addNewTest()
{
    hideStartWindow();
    testToAdd = new TestEntity();
    newTestWidget->show();
}

void adminwindow::hideStartWindow()
{
    ui->addNewTestBtn->hide();
    ui->checkProgressBtn->hide();
    ui->deleteTestBtn->hide();
    ui->label->hide();
    ui->lblMenu->hide();
    ui->logout_btn->hide();
}

void adminwindow::showStartWindow()
{
    ui->addNewTestBtn->show();
    ui->checkProgressBtn->show();
    ui->deleteTestBtn->show();
    ui->label->show();
    ui->lblMenu->show();
    ui->logout_btn->show();
    results->hide();
    ui->pushButton->hide();
}

void adminwindow::checkStats()
{

    QSqlQueryModel *model = new QSqlQueryModel(results);
    model->setQuery(QSqlQuery("SELECT * FROM test_results;", db));
    results->setModel(model);
    results->resize(600,400);
    results->show();
    ui->pushButton->show();

}

void adminwindow::hideAddWidget()
{
    newTestWidget->hide();
}

void adminwindow::deleteTest()
{
    deleteWidget->show();
}
