#include "loginwidget.h"
#include "tester.h"
#include "testselection.h"
#include <QGridLayout>
#include <QLabel>

LoginWidget::LoginWidget(QWidget *parent) : QWidget(parent)
{

    db = QSqlDatabase::addDatabase("QPSQL");
    db.setHostName("localhost");
    db.setDatabaseName("android_tester");
    db.setPort(5432);
    db.setUserName("postgres");
    db.setPassword("3868652");
    db.open();

    logins = new QSet<QString>();
    passwords = new QSet<QString>();

    QSqlQueryModel *sqlModel = new QSqlQueryModel();
    sqlModel->setQuery(QSqlQuery("SELECT login FROM admins;", db));
    int nameCount = sqlModel->rowCount();
    for (int i =0; i < nameCount; ++i) {
         logins->insert(sqlModel->index(i,0).data().toString());
         qDebug() << sqlModel->index(i,0).data().toString();
    }
    sqlModel->setQuery(QSqlQuery("SELECT passwords FROM admins;", db));
    for (int i =0; i < nameCount; ++i) {
         passwords->insert(sqlModel->index(i,0).data().toString());
         qDebug() << sqlModel->index(i,0).data().toString();
    }


    this->setWindowTitle("Приложение Тестер");
    QGridLayout* layout = new QGridLayout(this);
    send = new QPushButton("Отправить");
    nameEdit = new QLineEdit();
    passwordEdit = new QLineEdit();

    testerWindow = new Tester;
    testerWindow->hide();
    admWindow = new adminwindow();
    admWindow->hide();
    lab1 = new QLabel("Имя пользователя");
    lab2 = new QLabel("Пароль");
    isAdmin = new QCheckBox("Выполнить вход как администратор", this);
    passwordEdit->hide();
    lab2->hide();

    testerWindow = new Tester();

    layout->addWidget(lab1, 0, 0);
    layout->addWidget(nameEdit, 1, 0, 2, 1);
    layout->addWidget(isAdmin, 3, 0);
    layout->addWidget(lab2, 4, 0);
    layout->addWidget(passwordEdit, 5, 0 , 2, 1);
    layout->addWidget(send, 7, 0);

    this->setLayout(layout);
    this->resize(250, 200);

    connect(send, SIGNAL(clicked()), SLOT(sendInfo()));
    connect(this, &LoginWidget::onClosed, this, &Tester::show);
    connect(isAdmin, SIGNAL(stateChanged(int)), SLOT(isAdminlog(int)));
    connect(send, &QPushButton::clicked, this, &QWidget::close);
    connect(send, &QPushButton::clicked, this, &LoginWidget::onSendBtnClicked);
    connect(send, SIGNAL(clicked()), this, SLOT(isAdminLoginin()));


    this->show();
}

QString LoginWidget::getName()
{
    return this->nameEdit->text();
}

QString LoginWidget::getPassword()
{
    return this->passwordEdit->text();
}

void LoginWidget::sendInfo()
{
    // emit inf(nameEdit->text());
    testerWindow->receiveNameAndPassword(nameEdit->text());
}

void LoginWidget::isAdminlog(int check)
{
    if(check == Qt::CheckState::Checked)
    {
        lab2->show();
        passwordEdit->show();
    }
    else if(check == Qt::CheckState::Unchecked)
    {
        lab2->hide();
        passwordEdit->hide();
        // this->resize(250,200);
    }



}

void LoginWidget::isAdminLoginin()
{

    if(isAdmin->isChecked() && logins->contains(nameEdit->text()) && passwords->contains(passwordEdit->text()))
    {

        admWindow->show();
    }
    else if((isAdmin->isChecked() && !logins->contains(nameEdit->text())) || (isAdmin->isChecked() && !passwords->contains(passwordEdit->text())))
    {
         err = new QErrorMessage();
         err->showMessage("Логин или пароль неверны");
    }
    else
    {


        testerWindow->show();


    }
}



void LoginWidget::onSendBtnClicked()
{
    emit(onClosed());
}
